#!/bin/bash

getgid_of()
{
	cut -d: -f3 < <(getent group $1)
}

chall="$1"
user="chall-$chall"
home="/home/$user"

if [ -z "$chall" ]
then
	echo "Usage: $0 chall-name"
	exit 1
fi

useradd -m chall-$chall
cp $chall $chall.c $home
cp flag-$chall $home/flag

gid=$(getgid_of $user)

cat << EOL__ > $home/launcher.c
#include <unistd.h>
#include <stdlib.h>
#include <grp.h>

int main(int argc, char *argv[], char *envp[])
{
	uid_t uid = getuid();
	setuid(0);

	gid_t gid = $gid;
	if(setgroups(1, &gid) != 0 || setegid(gid) != 0 || setgid(gid) != 0) {
		return 1;
	}
	setuid(uid);

	chdir("$home");

	char name[] = "$chall";
	argv[0] = name;
	return execve("$home/$chall", argv, envp);
}
EOL__

gcc $home/launcher.c -o $home/launcher

chown -R 0:0 $home
chown :$user $home/$chall $home/flag $home/launcher
chmod g-w,o-r $home/flag $home/$chall $home/launcher
chmod o+r,o-x $home/$chall
chmod u+s $home/launcher
ls -al --color $home
